package cn.com.qmth.stmms.ms.accesscontrol;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import cn.com.qmth.stmms.ms.accesscontrol.config.LoginConfig;
import cn.com.qmth.stmms.ms.core.domain.user.AbstractUser;
import cn.com.qmth.stmms.ms.core.repository.MarkUserRepo;

public class LoginInterceptor extends HandlerInterceptorAdapter {
	
    @Autowired
    private MarkUserRepo markUserRepo;
    
    @Autowired
    private LoginConfig loginConfig;

	@Override
	public boolean preHandle(HttpServletRequest request,
			HttpServletResponse response, Object handler) throws Exception {
		String token = (String) request.getSession().getAttribute("token");
		if (token != null) {
			String loginName = token.substring(14);
			if(loginConfig.getLoginName().equals(loginName)){
				return true;
			}
			AbstractUser user = markUserRepo.findByLoginName(loginName);
			String sessionId = request.getSession().getId();
			if(user.getSessionId().equalsIgnoreCase(sessionId)){
				return true;
			}
		}
		response.sendError(HttpStatus.UNAUTHORIZED.value(), "没有登录或会话超时");
		return false;
	}

	public void postHandle(HttpServletRequest request,
			HttpServletResponse response) throws Exception {

	}

	public void afterCompletion(HttpServletRequest request,
			HttpServletResponse response, Object handler, Exception ex)
			throws Exception {

	}
}
